org.codehaus.groovy.transform

## Class ImmutableASTTransformation

- java.lang.Object
- - org.codehaus.groovy.transform.AbstractASTTransformation
  - - org.codehaus.groovy.transform.ImmutableASTTransformation

- All Implemented Interfaces:
    CompilationUnitAware, ASTTransformation, ErrorCollecting, org.objectweb.asm.Opcodes

      public class ImmutableASTTransformation
      extends AbstractASTTransformation
      implements CompilationUnitAware

  Handles generation of code for the @Immutable annotation.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static ClassNode` | `MY_TYPE`

    - ### Fields inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

      `RETENTION_CLASSNODE, sourceUnit`

    - ### Fields inherited from interface org.objectweb.asm.Opcodes

      `AALOAD, AASTORE, ACC_ABSTRACT, ACC_ANNOTATION, ACC_BRIDGE, ACC_DEPRECATED, ACC_ENUM, ACC_FINAL, ACC_INTERFACE, ACC_MANDATED, ACC_MODULE, ACC_NATIVE, ACC_OPEN, ACC_PRIVATE, ACC_PROTECTED, ACC_PUBLIC, ACC_STATIC, ACC_STATIC_PHASE, ACC_STRICT, ACC_SUPER, ACC_SYNCHRONIZED, ACC_SYNTHETIC, ACC_TRANSIENT, ACC_TRANSITIVE, ACC_VARARGS, ACC_VOLATILE, ACONST_NULL, ALOAD, ANEWARRAY, ARETURN, ARRAYLENGTH, ASM4, ASM5, ASM6, ASM7, ASM8_EXPERIMENTAL, ASTORE, ATHROW, BALOAD, BASTORE, BIPUSH, CALOAD, CASTORE, CHECKCAST, D2F, D2I, D2L, DADD, DALOAD, DASTORE, DCMPG, DCMPL, DCONST_0, DCONST_1, DDIV, DLOAD, DMUL, DNEG, DOUBLE, DREM, DRETURN, DSTORE, DSUB, DUP, DUP_X1, DUP_X2, DUP2, DUP2_X1, DUP2_X2, F_APPEND, F_CHOP, F_FULL, F_NEW, F_SAME, F_SAME1, F2D, F2I, F2L, FADD, FALOAD, FASTORE, FCMPG, FCMPL, FCONST_0, FCONST_1, FCONST_2, FDIV, FLOAD, FLOAT, FMUL, FNEG, FREM, FRETURN, FSTORE, FSUB, GETFIELD, GETSTATIC, GOTO, H_GETFIELD, H_GETSTATIC, H_INVOKEINTERFACE, H_INVOKESPECIAL, H_INVOKESTATIC, H_INVOKEVIRTUAL, H_NEWINVOKESPECIAL, H_PUTFIELD, H_PUTSTATIC, I2B, I2C, I2D, I2F, I2L, I2S, IADD, IALOAD, IAND, IASTORE, ICONST_0, ICONST_1, ICONST_2, ICONST_3, ICONST_4, ICONST_5, ICONST_M1, IDIV, IF_ACMPEQ, IF_ACMPNE, IF_ICMPEQ, IF_ICMPGE, IF_ICMPGT, IF_ICMPLE, IF_ICMPLT, IF_ICMPNE, IFEQ, IFGE, IFGT, IFLE, IFLT, IFNE, IFNONNULL, IFNULL, IINC, ILOAD, IMUL, INEG, INSTANCEOF, INTEGER, INVOKEDYNAMIC, INVOKEINTERFACE, INVOKESPECIAL, INVOKESTATIC, INVOKEVIRTUAL, IOR, IREM, IRETURN, ISHL, ISHR, ISTORE, ISUB, IUSHR, IXOR, JSR, L2D, L2F, L2I, LADD, LALOAD, LAND, LASTORE, LCMP, LCONST_0, LCONST_1, LDC, LDIV, LLOAD, LMUL, LNEG, LONG, LOOKUPSWITCH, LOR, LREM, LRETURN, LSHL, LSHR, LSTORE, LSUB, LUSHR, LXOR, MONITORENTER, MONITOREXIT, MULTIANEWARRAY, NEW, NEWARRAY, NOP, NULL, POP, POP2, PUTFIELD, PUTSTATIC, RET, RETURN, SALOAD, SASTORE, SIPUSH, SOURCE_DEPRECATED, SOURCE_MASK, SWAP, T_BOOLEAN, T_BYTE, T_CHAR, T_DOUBLE, T_FLOAT, T_INT, T_LONG, T_SHORT, TABLESWITCH, TOP, UNINITIALIZED_THIS, V_PREVIEW, V1_1, V1_2, V1_3, V1_4, V1_5, V1_6, V1_7, V1_8, V10, V11, V12, V13, V14, V15, V9`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ImmutableASTTransformation()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static Object` | `checkImmutable(Class<?> clazz, String fieldName, Object field)` For compatibility with pre 2.5 compiled classes
    `static Object` | `checkImmutable(Class<?> clazz, String fieldName, Object field, List<String> knownImmutableFieldNames, List<Class> knownImmutableClasses)`
    `static Object` | `checkImmutable(String className, String fieldName, Object field)` This method exists to be binary compatible with 1.7 - 1.8.6 compiled code.
    `static void` | `checkPropNames(Object instance, Map<String,Object> args)`
    `String` | `getAnnotationName()` If the transform is associated with a single annotation, returns a name suitable for displaying in error messages.
    `void` | `setCompilationUnit(CompilationUnit unit)`
    `void` | `visit(ASTNode[] nodes, SourceUnit source)` The method is invoked when an AST Transformation is active.

    - ### Methods inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

      `addError, checkIncludeExclude, checkIncludeExclude, checkIncludeExcludeUndefinedAware, checkIncludeExcludeUndefinedAware, checkNotInterface, checkPropertyList, checkPropertyList, checkPropertyList, copyAnnotatedNodeAnnotations, copyAnnotatedNodeAnnotations, deemedInternalName, getClassList, getMemberClassList, getMemberClassValue, getMemberClassValue, getMemberIntValue, getMemberList, getMemberStringList, getMemberStringValue, getMemberStringValue, getMemberValue, hasAnnotation, init, memberHasValue, nonGeneric, shouldSkip, shouldSkip, shouldSkipOnDescriptor, shouldSkipOnDescriptorUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, tokenize`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### MY_TYPE

          public static final ClassNode MY_TYPE

  - ### Constructor Detail

    - #### ImmutableASTTransformation

          public ImmutableASTTransformation()

  - ### Method Detail

    - #### getAnnotationName

          public String getAnnotationName()

      Description copied from class: `AbstractASTTransformation`
      If the transform is associated with a single annotation, returns a name suitable for displaying in error messages.
      Overrides:
        `getAnnotationName` in class `AbstractASTTransformation`
      Returns:
        The simple name of the annotation including the "@" or null if no such name is defined

    - #### visit

          public void visit(ASTNode[] nodes,
                            SourceUnit source)

      Description copied from interface: `ASTTransformation`
      The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.
      Specified by:
        `visit` in interface `ASTTransformation`
      Parameters:
        `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
        `source` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.

    - #### checkImmutable

          public static Object checkImmutable(String className,
                                              String fieldName,
                                              Object field)

      This method exists to be binary compatible with 1.7 - 1.8.6 compiled code.

    - #### checkImmutable

          public static Object checkImmutable(Class<?> clazz,
                                              String fieldName,
                                              Object field)

      For compatibility with pre 2.5 compiled classes

    - #### checkImmutable

          public static Object checkImmutable(Class<?> clazz,
                                              String fieldName,
                                              Object field,
                                              List<String> knownImmutableFieldNames,
                                              List<Class> knownImmutableClasses)

    - #### checkPropNames

          public static void checkPropNames(Object instance,
                                            Map<String,Object> args)

    - #### setCompilationUnit

          public void setCompilationUnit(CompilationUnit unit)

      Specified by:
        `setCompilationUnit` in interface `CompilationUnitAware`